"""
Call by python testNestInherit.py testType inputFilePrefix
If testType = 1 it tests just the first unit
If testType = 2 it tests individual unit
If testType = 3 it tests the inheritence hierarchy by starting each
             type and priming the rest so activation spreads up the
             hierarchy
"""
import sys
import numpy as np

import pyNN.nest as sim

from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions

from readInheritanceFile import InheritanceReaderClass
from readUnitFile import UnitReaderClass
from readAssocFile import AssocReaderClass
from makeInheritanceHier import NeuralInheritanceClass

def init():
    sim.setup(timestep=neal.DELAY,min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

#---main--
args = sys.argv
numberArgs = args.__len__()
if (numberArgs == 3):
    testType = int(args[1])
    fileName = args[2]
else:
    print "****Error*** This needs a test name"

simName = "nest"
spinnVersion = -1
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)

init()

pythonInheritanceStructure = InheritanceReaderClass()
baseFileName = fileName + "Bases"
pythonInheritanceStructure.readInheritanceFile(baseFileName)

print pythonInheritanceStructure.units
print pythonInheritanceStructure.isARelationships

neuralHierarchyTopology=NeuralInheritanceClass(simName,sim,neal,spinnVersion,
                                               fsa)
neuralHierarchyTopology.createNeuralInheritanceHierarchy(
            pythonInheritanceStructure)

numCAs = len(pythonInheritanceStructure.units)

print testType
if (testType == 1):
    neuralHierarchyTopology.createSimpleTest()
    simTime = 500
elif (testType == 2):
    neuralHierarchyTopology.createTestAllUnits(0) 
    simTime = numCAs*100

elif (testType == 3):
    neuralHierarchyTopology.createTestAllUnits(0) 
    neuralHierarchyTopology.createTestPrimeAllUnits(0,4) 
    simTime = numCAs*100

print simTime

neal.nealApplyProjections()
sim.run(simTime)

neuralHierarchyTopology.printInheritanceHier("results/inherit.pkl")
